=== modified file 'mystrings/ctype-bin.cc'
--- mystrings/ctype-bin.cc	2008-11-26 20:48:36 +0000
+++ mystrings/ctype-bin.cc	2008-12-01 08:04:52 +0000
@@ -66,18 +66,17 @@
 };
 
 
-extern "C"
 bool my_coll_init_8bit_bin(CHARSET_INFO *cs,
-                           void *(*)(size_t))
+                           cs_alloc_func)
 {
   cs->max_sort_char=255; 
   return false;
 }
 
-static int my_strnncoll_binary(const CHARSET_INFO * const,
-                               const unsigned char *s, size_t slen,
-                               const unsigned char *t, size_t tlen,
-                               bool t_is_prefix)
+int my_strnncoll_binary(const CHARSET_INFO * const,
+                        const unsigned char *s, size_t slen,
+                        const unsigned char *t, size_t tlen,
+                        bool t_is_prefix)
 {
   size_t len=cmin(slen,tlen);
   int cmp= memcmp(s,t,len);
@@ -85,9 +84,8 @@
 }
 
 
-static size_t my_lengthsp_binary(const CHARSET_INFO * const,
-                                 const char *,
-                                 size_t length)
+size_t my_lengthsp_binary(const CHARSET_INFO * const,
+                          const char *, size_t length)
 {
   return length;
 }
@@ -115,19 +113,19 @@
   > 0	s > t
 */
 
-static int my_strnncollsp_binary(const CHARSET_INFO * const cs,
-                                 const unsigned char *s, size_t slen,
-                                 const unsigned char *t, size_t tlen,
-                                 bool)
+int my_strnncollsp_binary(const CHARSET_INFO * const cs,
+                          const unsigned char *s, size_t slen,
+                          const unsigned char *t, size_t tlen,
+                          bool)
 {
   return my_strnncoll_binary(cs,s,slen,t,tlen,0);
 }
 
 
-static int my_strnncoll_8bit_bin(const CHARSET_INFO * const,
-                                 const unsigned char *s, size_t slen,
-                                 const unsigned char *t, size_t tlen,
-                                 bool t_is_prefix)
+int my_strnncoll_8bit_bin(const CHARSET_INFO * const,
+                          const unsigned char *s, size_t slen,
+                          const unsigned char *t, size_t tlen,
+                          bool t_is_prefix)
 {
   size_t len=cmin(slen,tlen);
   int cmp= memcmp(s,t,len);
@@ -160,10 +158,10 @@
   > 0	s > t
 */
 
-static int my_strnncollsp_8bit_bin(const CHARSET_INFO * const,
-                                   const unsigned char *a, size_t a_length, 
-                                   const unsigned char *b, size_t b_length,
-                                   bool diff_if_only_endspace_difference)
+int my_strnncollsp_8bit_bin(const CHARSET_INFO * const,
+                            const unsigned char *a, size_t a_length, 
+                            const unsigned char *b, size_t b_length,
+                            bool diff_if_only_endspace_difference)
 {
   const unsigned char *end;
   size_t length;
@@ -209,21 +207,21 @@
 
 /* This function is used for all conversion functions */
 
-static size_t my_case_str_bin(const CHARSET_INFO * const, char *)
+size_t my_case_str_bin(const CHARSET_INFO * const, char *)
 {
   return 0;
 }
 
 
-static size_t my_case_bin(const CHARSET_INFO * const, char *,
-                          size_t srclen, char *, size_t)
+size_t my_case_bin(const CHARSET_INFO * const, char *,
+                   size_t srclen, char *, size_t)
 {
   return srclen;
 }
 
 
-static int my_strcasecmp_bin(const CHARSET_INFO * const,
-			     const char *s, const char *t)
+int my_strcasecmp_bin(const CHARSET_INFO * const,
+                      const char *s, const char *t)
 {
   return strcmp(s,t);
 }
@@ -235,9 +233,9 @@
 }
 
 
-static int my_mb_wc_bin(const CHARSET_INFO * const,
-			my_wc_t *wc, const unsigned char *str,
-			const unsigned char *end)
+int my_mb_wc_bin(const CHARSET_INFO * const,
+                 my_wc_t *wc, const unsigned char *str,
+                 const unsigned char *end)
 {
   if (str >= end)
     return MY_CS_TOOSMALL;
@@ -247,10 +245,8 @@
 }
 
 
-static int my_wc_mb_bin(const CHARSET_INFO * const,
-			my_wc_t wc,
-			unsigned char *str,
-			unsigned char *end)
+int my_wc_mb_bin(const CHARSET_INFO * const, my_wc_t wc,
+                 unsigned char *str, unsigned char *end)
 {
   if (str >= end)
     return MY_CS_TOOSMALL;
@@ -264,7 +260,6 @@
 }
 
 
-extern "C"
 void my_hash_sort_8bit_bin(const CHARSET_INFO * const,
                            const unsigned char *key, size_t len,
                            uint32_t *nr1, uint32_t *nr2)
@@ -391,7 +386,7 @@
 }
 
 
-static size_t
+size_t
 my_strnxfrm_8bit_bin(const CHARSET_INFO * const cs,
                      unsigned char * dst, size_t dstlen, uint32_t nweights,
                      const unsigned char *src, size_t srclen, uint32_t flags)
@@ -405,11 +400,10 @@
 }
 
 
-static
 uint32_t my_instr_bin(const CHARSET_INFO * const,
-		  const char *b, size_t b_length,
-		  const char *s, size_t s_length,
-		  my_match_t *match, uint32_t nmatch)
+                      const char *b, size_t b_length,
+                      const char *s, size_t s_length,
+                      my_match_t *match, uint32_t nmatch)
 {
   register const unsigned char *str, *search, *end, *search_end;
 

=== modified file 'mystrings/ctype-mb.cc'
--- mystrings/ctype-mb.cc	2008-11-07 00:35:38 +0000
+++ mystrings/ctype-mb.cc	2008-12-01 08:04:52 +0000
@@ -362,7 +362,7 @@
 
 /* BINARY collations handlers for MB charsets */
 
-int my_strnncoll_mb_bin(const CHARSET_INFO * const  cs __attribute__((unused)),
+int my_strnncoll_mb_bin(const CHARSET_INFO * const,
                         const unsigned char *s, size_t slen,
                         const unsigned char *t, size_t tlen,
                         bool t_is_prefix)
@@ -398,7 +398,7 @@
     0 if strings are equal
 */
 
-int my_strnncollsp_mb_bin(const CHARSET_INFO * const  cs __attribute__((unused)),
+int my_strnncollsp_mb_bin(const CHARSET_INFO * const,
                           const unsigned char *a, size_t a_length,
                           const unsigned char *b, size_t b_length,
                           bool diff_if_only_endspace_difference)
@@ -552,15 +552,16 @@
 }
 
 
-int my_strcasecmp_mb_bin(const CHARSET_INFO * const  cs __attribute__((unused)),
+int my_strcasecmp_mb_bin(const CHARSET_INFO * const,
                          const char *s, const char *t)
 {
   return strcmp(s,t);
 }
 
 
-void my_hash_sort_mb_bin(const CHARSET_INFO * const cs __attribute__((unused)),
-                         const unsigned char *key, size_t len, uint32_t *nr1, uint32_t *nr2)
+void my_hash_sort_mb_bin(const CHARSET_INFO * const,
+                         const unsigned char *key, size_t len,
+                         uint32_t *nr1, uint32_t *nr2)
 {
   const unsigned char *pos = key;
   

=== modified file 'mystrings/ctype-simple.cc'
--- mystrings/ctype-simple.cc	2008-11-27 23:14:56 +0000
+++ mystrings/ctype-simple.cc	2008-12-01 08:04:52 +0000
@@ -215,12 +215,11 @@
 
 
 size_t my_caseup_8bit(const CHARSET_INFO * const  cs, char *src, size_t srclen,
-                      char *dst __attribute__((unused)),
-                      size_t dstlen __attribute__((unused)))
+                      char *dst, size_t dstlen)
 {
+  assert(src == dst && srclen == dstlen);
   char *end= src + srclen;
   register unsigned char *map= cs->to_upper;
-  assert(src == dst && srclen == dstlen);
   for ( ; src != end ; src++)
     *src= (char) map[(unsigned char) *src];
   return srclen;
@@ -228,12 +227,11 @@
 
 
 size_t my_casedn_8bit(const CHARSET_INFO * const  cs, char *src, size_t srclen,
-                      char *dst __attribute__((unused)),
-                      size_t dstlen __attribute__((unused)))
+                      char *dst, size_t dstlen)
 {
+  assert(src == dst && srclen == dstlen);
   char *end= src + srclen;
   register unsigned char *map=cs->to_lower;
-  assert(src == dst && srclen == dstlen);
   for ( ; src != end ; src++)
     *src= (char) map[(unsigned char) *src];
   return srclen;
@@ -250,7 +248,7 @@
 
 int my_mb_wc_8bit(const CHARSET_INFO * const cs,my_wc_t *wc,
 		  const unsigned char *str,
-		  const unsigned char *end __attribute__((unused)))
+		  const unsigned char *end)
 {
   if (str >= end)
     return MY_CS_TOOSMALL;
@@ -287,8 +285,8 @@
    end buffer must be checked.
 */
 
-size_t my_snprintf_8bit(const CHARSET_INFO * const cs  __attribute__((unused)),
-                        char* to, size_t n  __attribute__((unused)),
+size_t my_snprintf_8bit(const CHARSET_INFO * const,
+                        char* to, size_t n,
 		     const char* fmt, ...)
 {
   va_list args;
@@ -821,7 +819,7 @@
 */
 
 
-double my_strntod_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
+double my_strntod_8bit(const CHARSET_INFO * const,
 		       char *str, size_t length,
 		       char **end, int *err)
 {
@@ -838,7 +836,7 @@
   Assume len >= 1
 */
 
-size_t my_long10_to_str_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
+size_t my_long10_to_str_8bit(const CHARSET_INFO * const,
                              char *dst, size_t len, int radix, long int val)
 {
   char buffer[66];
@@ -879,9 +877,9 @@
 }
 
 
-size_t my_int64_t10_to_str_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
-                                 char *dst, size_t len, int radix,
-                                 int64_t val)
+size_t my_int64_t10_to_str_8bit(const CHARSET_INFO * const,
+                                char *dst, size_t len, int radix,
+                                int64_t val)
 {
   char buffer[65];
   register char *p, *e;
@@ -1123,37 +1121,35 @@
 }
 
 
-void my_fill_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
-		   char *s, size_t l, int fill)
+void my_fill_8bit(const CHARSET_INFO * const,
+		  char *s, size_t l, int fill)
 {
   memset(s, fill, l);
 }
 
 
-size_t my_numchars_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
-		      const char *b, const char *e)
+size_t my_numchars_8bit(const CHARSET_INFO * const,
+		        const char *b, const char *e)
 {
   return (size_t) (e - b);
 }
 
 
-size_t my_numcells_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
+size_t my_numcells_8bit(const CHARSET_INFO * const,
                         const char *b, const char *e)
 {
   return (size_t) (e - b);
 }
 
 
-size_t my_charpos_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
-                       const char *b  __attribute__((unused)),
-                       const char *e  __attribute__((unused)),
-                       size_t pos)
+size_t my_charpos_8bit(const CHARSET_INFO * const,
+                       const char *, const char *, size_t pos)
 {
   return pos;
 }
 
 
-size_t my_well_formed_len_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
+size_t my_well_formed_len_8bit(const CHARSET_INFO * const,
                                const char *start, const char *end,
                                size_t nchars, int *error)
 {
@@ -1163,7 +1159,7 @@
 }
 
 
-size_t my_lengthsp_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
+size_t my_lengthsp_8bit(const CHARSET_INFO * const,
                         const char *ptr, size_t length)
 {
   const char *end;
@@ -1253,7 +1249,7 @@
   return res;
 }
 
-static bool create_fromuni(CHARSET_INFO *cs, void *(*alloc)(size_t))
+static bool create_fromuni(CHARSET_INFO *cs, cs_alloc_func alloc)
 {
   uni_idx	idx[PLANE_NUM];
   int		i,n;
@@ -1332,8 +1328,7 @@
   return false;
 }
 
-extern "C"
-bool my_cset_init_8bit(CHARSET_INFO *cs, void *(*alloc)(size_t))
+bool my_cset_init_8bit(CHARSET_INFO *cs, cs_alloc_func alloc)
 {
   cs->caseup_multiply= 1;
   cs->casedn_multiply= 1;
@@ -1360,17 +1355,15 @@
   }
 }
 
-extern "C"
-bool my_coll_init_simple(CHARSET_INFO *cs,
-                         void *(*alloc)(size_t) __attribute__((unused)))
+bool my_coll_init_simple(CHARSET_INFO *cs, cs_alloc_func)
 {
   set_max_sort_char(cs);
   return false;
 }
 
 
-int64_t my_strtoll10_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
-                           const char *nptr, char **endptr, int *error)
+int64_t my_strtoll10_8bit(const CHARSET_INFO * const,
+                          const char *nptr, char **endptr, int *error)
 {
   return my_strtoll10(nptr, endptr, error);
 }
@@ -1478,7 +1471,7 @@
 */
 
 uint64_t
-my_strntoull10rnd_8bit(const CHARSET_INFO * const cs __attribute__((unused)),
+my_strntoull10rnd_8bit(const CHARSET_INFO * const,
                        const char *str, size_t length, int unsigned_flag,
                        char **endptr, int *error)
 {
@@ -1756,17 +1749,15 @@
 
 
 
-bool my_propagate_simple(const CHARSET_INFO * const cs __attribute__((unused)),
-                            const unsigned char *str __attribute__((unused)),
-                            size_t length __attribute__((unused)))
+bool my_propagate_simple(const CHARSET_INFO * const, const unsigned char *,
+                         size_t)
 {
   return 1;
 }
 
 
-bool my_propagate_complex(const CHARSET_INFO * const cs __attribute__((unused)),
-                             const unsigned char *str __attribute__((unused)),
-                             size_t length __attribute__((unused)))
+bool my_propagate_complex(const CHARSET_INFO * const, const unsigned char *,
+                          size_t)
 {
   return 0;
 }

=== modified file 'mystrings/ctype-uca.cc'
--- mystrings/ctype-uca.cc	2008-11-26 20:48:36 +0000
+++ mystrings/ctype-uca.cc	2008-12-01 08:04:52 +0000
@@ -7360,7 +7360,6 @@
 **	 1 if matched with wildcard
 */
 
-static
 int my_wildcmp_uca(const CHARSET_INFO * const cs,
 		   const char *str,const char *str_end,
 		   const char *wildstr,const char *wildend,
@@ -7865,7 +7864,7 @@
   default weights.
 */
 
-static bool create_tailoring(CHARSET_INFO *cs, void *(*alloc)(size_t))
+static bool create_tailoring(CHARSET_INFO *cs, cs_alloc_func alloc)
 {
   MY_COLL_RULE rule[MY_MAX_COLL_RULE];
   char errstr[128];
@@ -8023,33 +8022,31 @@
   Should work for any character set.
 */
 
-extern "C"
-bool my_coll_init_uca(CHARSET_INFO *cs, void *(*alloc)(size_t))
+bool my_coll_init_uca(CHARSET_INFO *cs, cs_alloc_func alloc)
 {
   cs->pad_char= ' ';
   return create_tailoring(cs, alloc);
 }
 
-static int my_strnncoll_any_uca(const CHARSET_INFO * const cs,
-                                const unsigned char *s, size_t slen,
-                                const unsigned char *t, size_t tlen,
-                                bool t_is_prefix)
+int my_strnncoll_any_uca(const CHARSET_INFO * const cs,
+                         const unsigned char *s, size_t slen,
+                         const unsigned char *t, size_t tlen,
+                         bool t_is_prefix)
 {
   return my_strnncoll_uca(cs, &my_any_uca_scanner_handler,
                           s, slen, t, tlen, t_is_prefix);
 }
 
-static int my_strnncollsp_any_uca(const CHARSET_INFO * const cs,
-                                  const unsigned char *s, size_t slen,
-                                  const unsigned char *t, size_t tlen,
-                                  bool diff_if_only_endspace_difference)
+int my_strnncollsp_any_uca(const CHARSET_INFO * const cs,
+                           const unsigned char *s, size_t slen,
+                           const unsigned char *t, size_t tlen,
+                           bool diff_if_only_endspace_difference)
 {
   return my_strnncollsp_uca(cs, &my_any_uca_scanner_handler,
                             s, slen, t, tlen,
                             diff_if_only_endspace_difference);
 }   
 
-extern "C"
 void my_hash_sort_any_uca(const CHARSET_INFO * const cs,
                           const unsigned char *s, size_t slen,
                           uint32_t *n1, uint32_t *n2)
@@ -8057,9 +8054,10 @@
   my_hash_sort_uca(cs, &my_any_uca_scanner_handler, s, slen, n1, n2); 
 }
 
-static size_t my_strnxfrm_any_uca(const CHARSET_INFO * const cs, 
-                                  unsigned char *dst, size_t dstlen, uint32_t nweights,
-                                  const unsigned char *src, size_t srclen, uint32_t flags)
+size_t my_strnxfrm_any_uca(const CHARSET_INFO * const cs, 
+                           unsigned char *dst, size_t dstlen, uint32_t nweights,
+                           const unsigned char *src, size_t srclen,
+                           uint32_t flags)
 {
   return my_strnxfrm_uca(cs, &my_any_uca_scanner_handler,
                          dst, dstlen, nweights, src, srclen, flags);

=== modified file 'mystrings/ctype-utf8.cc'
--- mystrings/ctype-utf8.cc	2008-11-26 20:48:36 +0000
+++ mystrings/ctype-utf8.cc	2008-12-01 08:04:52 +0000
@@ -1958,8 +1958,8 @@
 }
 
 
-static int
-my_mb_wc_utf8mb4(const CHARSET_INFO * const cs __attribute__((unused)),
+int
+my_mb_wc_utf8mb4(const CHARSET_INFO * const,
                  my_wc_t * pwc, const unsigned char *s, const unsigned char *e)
 {
   unsigned char c;
@@ -2025,7 +2025,7 @@
   for example, for a null-terminated string
 */
 static int
-my_mb_wc_utf8mb4_no_range(const CHARSET_INFO * const cs __attribute__((unused)),
+my_mb_wc_utf8mb4_no_range(const CHARSET_INFO * const,
                           my_wc_t *pwc, const unsigned char *s)
 {
   unsigned char c;
@@ -2078,8 +2078,8 @@
 }
 
 
-static int
-my_wc_mb_utf8mb4(const CHARSET_INFO * const cs __attribute__((unused)),
+int
+my_wc_mb_utf8mb4(const CHARSET_INFO * const,
                  my_wc_t wc, unsigned char *r, unsigned char *e)
 {
   int count;
@@ -2115,7 +2115,7 @@
   The same as above, but without range check.
 */
 static int
-my_wc_mb_utf8mb4_no_range(const CHARSET_INFO * const cs __attribute__((unused)),
+my_wc_mb_utf8mb4_no_range(const CHARSET_INFO * const,
                           my_wc_t wc, unsigned char *r)
 {
   int count;
@@ -2180,7 +2180,7 @@
 }
 
 
-static size_t
+size_t
 my_caseup_utf8mb4(const CHARSET_INFO * const cs, char *src, size_t srclen,
                   char *dst, size_t dstlen)
 {
@@ -2250,7 +2250,7 @@
 }
 
 
-static size_t
+size_t
 my_caseup_str_utf8mb4(const CHARSET_INFO * const cs, char *src)
 {
   my_wc_t wc;
@@ -2273,7 +2273,7 @@
 }
 
 
-static size_t
+size_t
 my_casedn_utf8mb4(const CHARSET_INFO * const cs,
                   char *src, size_t srclen,
                   char *dst, size_t dstlen)
@@ -2298,7 +2298,7 @@
 }
 
 
-static size_t
+size_t
 my_casedn_str_utf8mb4(const CHARSET_INFO * const cs, char *src)
 {
   my_wc_t wc;
@@ -2337,7 +2337,7 @@
 }
 
 
-static int
+int
 my_strnncoll_utf8mb4(const CHARSET_INFO * const cs,
                      const unsigned char *s, size_t slen,
                      const unsigned char *t, size_t tlen,
@@ -2402,7 +2402,7 @@
     @retval Positive number, if a > b
 */
 
-static int
+int
 my_strnncollsp_utf8mb4(const CHARSET_INFO * const cs,
                        const unsigned char *s, size_t slen,
                        const unsigned char *t, size_t tlen,
@@ -2491,8 +2491,8 @@
     @retval 0 is the strings are equal
 */
 
-static int
-my_strcasecmp_utf8mb4(const CHARSET_INFO * const cs, const char *s, const char *t)
+int my_strcasecmp_utf8mb4(const CHARSET_INFO * const cs,
+                          const char *s, const char *t)
 {
   MY_UNICASE_INFO **uni_plane= cs->caseinfo;
   while (s[0] && t[0])
@@ -2551,7 +2551,7 @@
 }
 
 
-static int
+int
 my_wildcmp_utf8mb4(const CHARSET_INFO * const cs,
                    const char *str, const char *strend,
                    const char *wildstr, const char *wildend,
@@ -2562,15 +2562,15 @@
 }
 
 
-static size_t
-my_strnxfrmlen_utf8mb4(const CHARSET_INFO * const cs __attribute__((unused)), size_t len)
+size_t
+my_strnxfrmlen_utf8mb4(const CHARSET_INFO * const, size_t len)
 {
   /* TODO: fix when working on WL "Unicode new version" */
   return (len * 2 + 2) / 4;
 }
 
 
-static size_t
+size_t
 my_strnxfrm_utf8mb4(const CHARSET_INFO * const cs,
                     unsigned char *dst, size_t dstlen, uint32_t nweights,
                     const unsigned char *src, size_t srclen, uint32_t flags)
@@ -2615,8 +2615,8 @@
 }
 
 
-static uint
-my_ismbchar_utf8mb4(const CHARSET_INFO * const cs, const char *b, const char *e)
+unsigned int my_ismbchar_utf8mb4(const CHARSET_INFO * const cs,
+                                 const char *b, const char *e)
 {
   my_wc_t wc;
   int res= my_mb_wc_utf8mb4(cs,&wc, (const unsigned char*)b, (const unsigned char*)e);
@@ -2624,8 +2624,7 @@
 }
 
 
-static uint
-my_mbcharlen_utf8mb4(const CHARSET_INFO * const cs  __attribute__((unused)), uint32_t c)
+unsigned int my_mbcharlen_utf8mb4(const CHARSET_INFO * const, uint32_t c)
 {
   if (c < 0x80)
     return 1;
@@ -2856,9 +2855,9 @@
 }
 
 
-static int
-my_mb_wc_utf8mb3(const CHARSET_INFO * const cs __attribute__((unused)),
-                 my_wc_t * pwc, const unsigned char *s, const unsigned char *e)
+int
+my_mb_wc_utf8mb3(const CHARSET_INFO * const, my_wc_t * pwc,
+                 const unsigned char *s, const unsigned char *e)
 {
   unsigned char c;
 
@@ -2968,7 +2967,7 @@
   for example, for a null-terminated string
 */
 static int
-my_mb_wc_utf8mb3_no_range(const CHARSET_INFO * const cs __attribute__((unused)),
+my_mb_wc_utf8mb3_no_range(const CHARSET_INFO * const,
                           my_wc_t * pwc, const unsigned char *s)
 {
   unsigned char c;
@@ -3009,9 +3008,8 @@
 }
 
 
-static int
-my_wc_mb_utf8mb3(const CHARSET_INFO * const cs __attribute__((unused)),
-                 my_wc_t wc, unsigned char *r, unsigned char *e)
+int my_wc_mb_utf8mb3(const CHARSET_INFO * const,
+                     my_wc_t wc, unsigned char *r, unsigned char *e)
 {
   int count;
 
@@ -3060,7 +3058,7 @@
   The same as above, but without range check.
 */
 static int
-my_wc_mb_utf8mb3_no_range(const CHARSET_INFO * const cs __attribute__((unused)),
+my_wc_mb_utf8mb3_no_range(const CHARSET_INFO * const,
                           my_wc_t wc, unsigned char *r)
 {
   int count;
@@ -3085,7 +3083,7 @@
 }
 
 
-static size_t
+size_t
 my_caseup_utf8mb3(const CHARSET_INFO * const cs, char *src, size_t srclen,
                   char *dst, size_t dstlen)
 {
@@ -3141,7 +3139,7 @@
 }
 
 
-static size_t
+size_t
 my_caseup_str_utf8mb3(const CHARSET_INFO * const cs, char *src)
 {
   my_wc_t wc;
@@ -3165,7 +3163,7 @@
 }
 
 
-static size_t
+size_t
 my_casedn_utf8mb3(const CHARSET_INFO * const cs, char *src, size_t srclen,
                   char *dst, size_t dstlen)
 {
@@ -3190,7 +3188,7 @@
 }
 
 
-static size_t
+size_t
 my_casedn_str_utf8mb3(const CHARSET_INFO * const cs, char *src)
 {
   my_wc_t wc;
@@ -3230,7 +3228,7 @@
 }
 
 
-static int
+int
 my_strnncoll_utf8mb3(const CHARSET_INFO * const cs,
                      const unsigned char *s, size_t slen,
                      const unsigned char *t, size_t tlen,
@@ -3298,7 +3296,7 @@
     @retval Positive number, if a > b
 */
 
-static int
+int
 my_strnncollsp_utf8mb3(const CHARSET_INFO * const cs,
                        const unsigned char *s, size_t slen,
                        const unsigned char *t, size_t tlen,
@@ -3392,8 +3390,9 @@
     - 0 is the strings are equal
 */
 
-static int
-my_strcasecmp_utf8mb3(const CHARSET_INFO * const cs, const char *s, const char *t)
+int
+my_strcasecmp_utf8mb3(const CHARSET_INFO * const cs,
+                      const char *s, const char *t)
 {
   MY_UNICASE_INFO **uni_plane= cs->caseinfo;
   while (s[0] && t[0])
@@ -3475,7 +3474,7 @@
 }
 
 
-static int
+int
 my_wildcmp_utf8mb3(const CHARSET_INFO * const cs,
 		   const char *str,const char *str_end,
 		   const char *wildstr,const char *wildend,
@@ -3487,14 +3486,14 @@
 }
 
 
-static size_t
-my_strnxfrmlen_utf8mb3(const CHARSET_INFO * const cs __attribute__((unused)), size_t len)
+size_t
+my_strnxfrmlen_utf8mb3(const CHARSET_INFO * const, size_t len)
 {
   return (len * 2 + 2) / 3;
 }
 
 
-static size_t
+size_t
 my_strnxfrm_utf8mb3(const CHARSET_INFO * const cs,
                     unsigned char *dst, size_t dstlen, uint32_t nweights,
                     const unsigned char *src, size_t srclen, uint32_t flags)
@@ -3539,7 +3538,7 @@
 }
 
 
-static size_t
+size_t
 my_strnxfrm_utf8mb3_bin(const CHARSET_INFO * const cs,
                         unsigned char *dst, size_t dstlen, uint32_t nweights,
                         const unsigned char *src, size_t srclen, uint32_t flags)
@@ -3578,7 +3577,7 @@
 }
 
 
-static uint
+unsigned int
 my_ismbchar_utf8mb3(const CHARSET_INFO * const cs, const char *b, const char *e)
 {
   my_wc_t wc;
@@ -3587,8 +3586,8 @@
 }
 
 
-static uint
-my_mbcharlen_utf8mb3(const CHARSET_INFO * const cs  __attribute__((unused)), uint32_t c)
+unsigned int
+my_mbcharlen_utf8mb3(const CHARSET_INFO * const, uint32_t c)
 {
   if (c < 0x80)
     return 1;
@@ -3755,7 +3754,7 @@
  * variable to what they actually do.
  */
 
-static int
+int
 my_strnncoll_utf8mb3_cs(CHARSET_INFO *cs, 
                         const unsigned char *s, size_t slen,
                         const unsigned char *t, size_t tlen,
@@ -3802,7 +3801,7 @@
   return t_is_prefix ? t-te : ((diff == 0) ? save_diff : diff);
 }
 
-static int
+int
 my_strnncollsp_utf8mb3_cs(CHARSET_INFO *cs, 
                           const unsigned char *s, size_t slen,
                           const unsigned char *t, size_t tlen,
@@ -5054,8 +5053,8 @@
 
 #define MY_FILENAME_ESCAPE '@'
 
-static int
-my_mb_wc_filename(const CHARSET_INFO * const cs __attribute__((unused)),
+int
+my_mb_wc_filename(const CHARSET_INFO * const,
                   my_wc_t *pwc, const unsigned char *s, const unsigned char *e)
 {
   int byte1, byte2;
@@ -5112,8 +5111,8 @@
 }
 
 
-static int
-my_wc_mb_filename(const CHARSET_INFO * const cs __attribute__((unused)),
+int
+my_wc_mb_filename(const CHARSET_INFO * const,
                   my_wc_t wc, unsigned char *s, unsigned char *e)
 {
   int code;

=== modified file 'mystrings/m_ctype.h'
--- mystrings/m_ctype.h	2008-11-27 23:14:56 +0000
+++ mystrings/m_ctype.h	2008-12-01 08:04:52 +0000
@@ -475,6 +475,9 @@
 size_t my_charpos_8bit(const CHARSET_INFO * const, const char *b, const char *e, size_t pos);
 size_t my_well_formed_len_8bit(const CHARSET_INFO * const, const char *b, const char *e,
                              size_t pos, int *error);
+typedef  void *(*cs_alloc_func)(size_t);
+bool my_coll_init_simple(CHARSET_INFO *cs, cs_alloc_func alloc);
+bool my_cset_init_8bit(CHARSET_INFO *cs, cs_alloc_func alloc);
 uint32_t my_mbcharlen_8bit(const CHARSET_INFO * const, uint32_t c);
 
 
@@ -553,6 +556,216 @@
 
 bool my_charset_is_ascii_compatible(const CHARSET_INFO * const cs);
 
+int
+my_strnncoll_utf8mb3(const CHARSET_INFO * const cs,
+                     const unsigned char *s, size_t slen,
+                     const unsigned char *t, size_t tlen,
+                     bool t_is_prefix);
+
+int
+my_strnncollsp_utf8mb3(const CHARSET_INFO * const cs,
+                       const unsigned char *s, size_t slen,
+                       const unsigned char *t, size_t tlen,
+                       bool diff_if_only_endspace_difference);
+
+size_t
+my_strnxfrm_utf8mb3(const CHARSET_INFO * const cs,
+                    unsigned char *dst, size_t dstlen, uint32_t nweights,
+                    const unsigned char *src, size_t srclen, uint32_t flags);
+
+size_t
+my_strnxfrmlen_utf8mb3(const CHARSET_INFO * const cs, size_t len);
+
+size_t my_strnxfrm_utf8mb3_bin(const CHARSET_INFO * const cs,
+                               unsigned char *dst, size_t dstlen, 
+                               uint32_t nweights, const unsigned char *src,
+                               size_t srclen, uint32_t flags);
+/*
+  Compare 0-terminated UTF8 strings.
+
+  SYNOPSIS
+    my_strcasecmp_utf8mb3()
+    cs                  character set handler
+    s                   First 0-terminated string to compare
+    t                   Second 0-terminated string to compare
+
+  IMPLEMENTATION
+
+  RETURN
+    - negative number if s < t
+    - positive number if s > t
+    - 0 is the strings are equal
+*/
+int
+my_strcasecmp_utf8mb3(const CHARSET_INFO * const cs,
+                      const char *s, const char *t);
+
+int
+my_strnncoll_utf8mb3_cs(CHARSET_INFO *cs,
+                        const unsigned char *s, size_t slen,
+                        const unsigned char *t, size_t tlen,
+                        bool t_is_prefix);
+
+int
+my_strnncollsp_utf8mb3_cs(CHARSET_INFO *cs,
+                          const unsigned char *s, size_t slen,
+                          const unsigned char *t, size_t tlen,
+                          bool diff_if_only_endspace_difference);
+
+int
+my_wildcmp_utf8mb3(const CHARSET_INFO * const cs,
+                   const char *str,const char *str_end,
+                   const char *wildstr,const char *wildend,
+                   int escape, int w_one, int w_many);
+
+unsigned int
+my_ismbchar_utf8mb3(const CHARSET_INFO * const cs,
+                    const char *b, const char *e);
+
+int
+my_wc_mb_filename(const CHARSET_INFO * const,
+                  my_wc_t wc, unsigned char *s, unsigned char *e);
+
+int
+my_mb_wc_filename(const CHARSET_INFO * const,
+                  my_wc_t *pwc, const unsigned char *s, const unsigned char *e);
+
+size_t
+my_caseup_str_utf8mb3(const CHARSET_INFO * const cs, char *src);
+size_t
+my_casedn_str_utf8mb3(const CHARSET_INFO * const cs, char *src);
+size_t
+my_caseup_utf8mb3(const CHARSET_INFO * const cs, char *src, size_t srclen,
+                  char *dst, size_t dstlen);
+size_t
+my_casedn_utf8mb3(const CHARSET_INFO * const cs, char *src, size_t srclen,
+                  char *dst, size_t dstlen);
+
+int my_mb_wc_utf8mb3(const CHARSET_INFO * const, my_wc_t * pwc,
+                     const unsigned char *s, const unsigned char *e);
+int my_wc_mb_utf8mb3(const CHARSET_INFO * const,
+                     my_wc_t wc, unsigned char *r, unsigned char *e);
+
+unsigned int
+my_mbcharlen_utf8mb3(const CHARSET_INFO * const, uint32_t c);
+ 
+unsigned int my_ismbchar_utf8mb4(const CHARSET_INFO * const cs,                                  const char *b, const char *e);
+unsigned int my_mbcharlen_utf8mb4(const CHARSET_INFO * const, uint32_t c);
+
+size_t my_strnxfrmlen_utf8mb4(const CHARSET_INFO * const, size_t len);
+size_t
+my_strnxfrm_utf8mb4(const CHARSET_INFO * const cs,
+                    unsigned char *dst, size_t dstlen, uint32_t nweights,
+                    const unsigned char *src, size_t srclen, uint32_t flags);
+
+int
+my_wildcmp_utf8mb4(const CHARSET_INFO * const cs,
+                   const char *str, const char *strend,
+                   const char *wildstr, const char *wildend,
+                   int escape, int w_one, int w_many);
+int
+my_strnncollsp_utf8mb4(const CHARSET_INFO * const cs,
+                       const unsigned char *s, size_t slen,
+                       const unsigned char *t, size_t tlen,
+                       bool diff_if_only_endspace_difference);
+int my_strcasecmp_utf8mb4(const CHARSET_INFO * const cs,
+                          const char *s, const char *t);
+
+int
+my_strnncoll_utf8mb4(const CHARSET_INFO * const cs,
+                     const unsigned char *s, size_t slen,
+                     const unsigned char *t, size_t tlen,
+                     bool t_is_prefix);
+
+int
+my_mb_wc_utf8mb4(const CHARSET_INFO * const cs,
+                 my_wc_t * pwc, const unsigned char *s, const unsigned char *e);
+
+int
+my_wc_mb_utf8mb4(const CHARSET_INFO * const cs,
+                 my_wc_t wc, unsigned char *r, unsigned char *e);
+
+size_t my_caseup_str_utf8mb4(const CHARSET_INFO * const cs, char *src);
+size_t my_casedn_str_utf8mb4(const CHARSET_INFO * const cs, char *src);
+
+size_t
+my_caseup_utf8mb4(const CHARSET_INFO * const cs, char *src, size_t srclen,
+                  char *dst, size_t dstlen);
+size_t
+my_casedn_utf8mb4(const CHARSET_INFO * const cs,
+                  char *src, size_t srclen,
+                  char *dst, size_t dstlen);
+
+
+bool my_coll_init_uca(CHARSET_INFO *cs, cs_alloc_func alloc);
+
+int my_strnncoll_any_uca(const CHARSET_INFO * const cs,
+                         const unsigned char *s, size_t slen,
+                         const unsigned char *t, size_t tlen,
+                         bool t_is_prefix);
+
+int my_strnncollsp_any_uca(const CHARSET_INFO * const cs,
+                           const unsigned char *s, size_t slen,
+                           const unsigned char *t, size_t tlen,
+                           bool diff_if_only_endspace_difference);
+
+void my_hash_sort_any_uca(const CHARSET_INFO * const cs,
+                          const unsigned char *s, size_t slen,
+                          uint32_t *n1, uint32_t *n2);
+
+size_t my_strnxfrm_any_uca(const CHARSET_INFO * const cs,       
+                           unsigned char *dst, size_t dstlen, uint32_t nweights,
+                           const unsigned char *src, size_t srclen,
+                           uint32_t flags);
+
+int my_wildcmp_uca(const CHARSET_INFO * const cs,
+                   const char *str,const char *str_end,
+                   const char *wildstr,const char *wildend,
+                   int escape, int w_one, int w_many);
+
+int my_strnncoll_8bit_bin(const CHARSET_INFO * const,
+                          const unsigned char *s, size_t slen,
+                          const unsigned char *t, size_t tlen,
+                          bool t_is_prefix);
+int my_strnncollsp_8bit_bin(const CHARSET_INFO * const,
+                            const unsigned char *a, size_t a_length,       
+                            const unsigned char *b, size_t b_length,
+                            bool diff_if_only_endspace_difference);
+size_t my_case_str_bin(const CHARSET_INFO * const, char *);
+size_t my_case_bin(const CHARSET_INFO * const, char *,
+                   size_t srclen, char *, size_t);
+int my_strcasecmp_bin(const CHARSET_INFO * const,
+                      const char *s, const char *t);
+size_t
+my_strnxfrm_8bit_bin(const CHARSET_INFO * const cs,
+                     unsigned char * dst, size_t dstlen, uint32_t nweights,
+                     const unsigned char *src, size_t srclen, uint32_t flags);
+uint32_t my_instr_bin(const CHARSET_INFO * const,
+                      const char *b, size_t b_length,
+                      const char *s, size_t s_length,
+                      my_match_t *match, uint32_t nmatch);
+size_t my_lengthsp_binary(const CHARSET_INFO * const,
+                          const char *, size_t length);
+int my_mb_wc_bin(const CHARSET_INFO * const,
+                 my_wc_t *wc, const unsigned char *str,
+                 const unsigned char *end);
+int my_wc_mb_bin(const CHARSET_INFO * const, my_wc_t wc,
+                 unsigned char *str, unsigned char *end);
+void my_hash_sort_8bit_bin(const CHARSET_INFO * const,
+                           const unsigned char *key, size_t len,
+                           uint32_t *nr1, uint32_t *nr2);
+bool my_coll_init_8bit_bin(CHARSET_INFO *cs,
+                           cs_alloc_func);
+int my_strnncoll_binary(const CHARSET_INFO * const,
+                        const unsigned char *s, size_t slen,
+                        const unsigned char *t, size_t tlen,
+                        bool t_is_prefix);
+int my_strnncollsp_binary(const CHARSET_INFO * const cs,
+                          const unsigned char *s, size_t slen,
+                          const unsigned char *t, size_t tlen,
+                          bool);
+
+
 #define	_MY_U	01	/* Upper case */
 #define	_MY_L	02	/* Lower case */
 #define	_MY_NMR	04	/* Numeral (digit) */

=== modified file 'mystrings/m_string.h'
--- mystrings/m_string.h	2008-11-27 23:14:56 +0000
+++ mystrings/m_string.h	2008-12-01 08:04:52 +0000
@@ -53,8 +53,14 @@
   my_str_malloc() and my_str_free() are assigned to implementations in
   strings/alloc.c, but can be overridden in the calling program.
  */
-extern void *(*my_str_malloc)(size_t);
-extern void (*my_str_free)(void *);
+typedef void *(*str_malloc_func)(size_t);
+typedef void (*str_free_func)(void *);
+
+extern str_malloc_func my_str_malloc;
+extern str_free_func my_str_free;
+
+void *my_str_malloc_default(size_t size);
+void my_str_free_default(void *ptr);
 
 char *my_stpncpy(register char *dst, register const char *src, size_t n);
 char *my_stpcpy(register char *dst, register const char *src);

=== modified file 'mystrings/my_strtoll10.cc'
--- mystrings/my_strtoll10.cc	2008-11-07 00:35:38 +0000
+++ mystrings/my_strtoll10.cc	2008-12-01 08:04:52 +0000
@@ -78,7 +78,7 @@
   unsigned long i, j, k;
   uint64_t li;
   int negative;
-  unsigned long cutoff, cutoff2, cutoff3;
+  uint64_t cutoff, cutoff2, cutoff3;
 
   s= nptr;
   /* If fixed length string */

=== modified file 'mystrings/str_alloc.cc'
--- mystrings/str_alloc.cc	2008-11-27 23:14:56 +0000
+++ mystrings/str_alloc.cc	2008-12-01 08:04:52 +0000
@@ -16,7 +16,7 @@
 #include <mystrings/m_string.h>
 #include <stdlib.h>
 
-static void *my_str_malloc_default(size_t size)
+void *my_str_malloc_default(size_t size)
 {
   void *ret= malloc(size);
   if (!ret)
@@ -24,10 +24,10 @@
   return ret;
 }
 
-static void my_str_free_default(void *ptr)
+void my_str_free_default(void *ptr)
 {
   free(ptr);
 }
 
-void *(*my_str_malloc)(size_t)= &my_str_malloc_default;
-void (*my_str_free)(void *)= &my_str_free_default;
+str_malloc_func my_str_malloc= &my_str_malloc_default;
+str_free_func my_str_free= &my_str_free_default;

